<?php
// Edit these lines only.
// This is a list your players token names.  The number after the name doesn't matter for now.
$kwnplrs=array("Blint"=>"10", "Silom"=>"10", "Enna"=>"10", "RedClaw"=>"10", "Goujin"=>"10");
// This is where the webserver will store the data file.
$filename="/tmp/mobs.txt";

function writeit($info,$file){
    $myfile = fopen($file, "w") or die("Unable to open file!");
    foreach($info as $v){
        fwrite($myfile, $v."\n");
    }
    fclose($myfile);
}

function readit($file){
    $lines = file($file, FILE_IGNORE_NEW_LINES);
    return $lines;
}

function percent($min, $max){return floor(($min/$max)*100);}

function getField($token, $field){
    $line=explode(":", $token);
    switch ($field){
        case "id":
            return $line[0];
        case "hp":
            return $line[1];
        case "name":
            return $line[2];
        case "max":
            return $line[3];
    }
}

function updateField($token, $field, $value){
    $id=getField($token, "id");
    $hp=getField($token, "hp");
    $name=getField($token, "name");
    $max=getField($token, "max");
    switch ($field){
        case "id":
            $id=$value;
            break;
        case "hp":
            if ($value>$max){$value=$max;}
            $hp=$value;
            break;
        case "name":
            $name=$value;
            break;
        case "max":
            $max=$value;
            break;
    }
    return $id.":".$hp.":".$name.":".$max;
}

function update($token, $amt){
    $id=getField($token, "id");
    $hp=getField($token, "hp");
}

function getPlayers($tokens){
    $rtn=array();
    foreach($tokens as $token){
        $line=explode(":", $token);
        $name=$line[2];
        if(array_key_exists($name, $GLOBALS['kwnplrs'])){
            array_push($rtn, $token);
        }
    }
    return $rtn;
}

function getMobs($tokens){
    $rtn=array();
    foreach($tokens as $token){
        $line=explode(":", $token);
        $name=$line[2];
        if(!array_key_exists($name, $GLOBALS['kwnplrs'])){
            array_push($rtn, $token);
        }
    }
    return $rtn;
}

function style($cur, $max, $name, $id){
    $sid=substr($id,0,6);
    $per=percent($cur,$max);
    $color="#4CAF50";
    if ($per < 50){$color="#f44336";}
    return ".a".$id." {width: ".$per."%;background-color: ".$color.";}";
}

function styleHead($gm){
    $page="player.php";
    if($gm){$page="gm.php";}
    ?>
<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta http-equiv="refresh" content="30;URL='<?php echo $page; ?>'" />
<style>
body { background-color: #383838;color: #c4c4c4;}
* {box-sizing: border-box}

.container {
  width: 60px;
  background-color: #ddd;
  color: black;
}
input {width: 61px;}
td {padding: 20px;border: 1px solid black;}
table {border-collapse: collapse;}
</style>
<?php
}

function infoBlock($name, $per, $cnt, $id, $hp, $gm, $page){
    $reset=false;
    echo "<td><center>".$name."</center><p>";
    echo "<div class='container'>";
    echo "<div class='a".$id."'>".$per."%</div>";
    echo "</div>";
    if ($gm){
        echo "<form action='".$page."' method='post' name='".$id."'>";
        echo "<input type='number' name='amt' min='-500' max='500'>";
        echo "<input type=hidden name='id' value='".$id."'>";
        echo "<input type=hidden name='name' value='".$name."'>";
        echo "<input type=hidden name='hp' value='".$hp."'><br>";
        echo "<input type=submit name=update value=update></form>";
    }
    echo "</td>";
    if($cnt >= 2){echo "</tr><tr>";$reset=true;}
    return $reset;
}

function displayit($tokens, $gm, $page){
    echo "<style>";
    foreach($tokens as $token){
        $id=getField($token, "id");
        $hp=getField($token, "hp");
        $name=getField($token, "name");
        $max=getField($token, "max");
        $rtn=style($hp, $max, $name, $id);
        echo $rtn;
    }
    echo "</style>";
    echo "<table><tr>";
    $cnt=0;
    foreach($tokens as $token){
        $id=getField($token, "id");
        $hp=getField($token, "hp");
        $name=getField($token, "name");
        $max=getField($token, "max");
        $rtn=infoBlock($name, percent($hp, $max), $cnt, $id, $hp, $gm, $page);
        $cnt++;
        if($rtn){$cnt=0;}
    }
    echo "</tr></table>";
}


?>
